
delete from flow.calendar_timezone_offsets;

insert into flow.calendar_timezone_offsets (id, utc_offset, names)
select rank() over(order by utc_offset) id, utc_offset, array_agg(name) as names
from pg_timezone_names
where not name ilike '%pos%' and not exists(select 1 from flow.calendar_timezone_offsets)
group by utc_offset
order by utc_offset;

update flow.calendar_timezones c
set name = x.name,
    utc_offset = x.utc_offset,
    offset_id = x.offset_id
from (
     select
        c.id,
        c.sys_name || ' ' || substring(tt.utc_offset::text, 1, length(tt.utc_offset::text) - 3) as name,
        tt.utc_offset,
        o.id offset_id,
        c.sys_name
    from pg_timezone_names tt
        inner join flow.calendar_timezones c on c.sys_name = tt.name
        left join lateral (
            select *
            from flow.calendar_timezone_offsets o
            where o.names && array [c.sys_name]
        ) o on true
) x
where c.id = x.id;


update call_center.cc_member m
set sys_offset_id = c.offset_id
from call_center.cc_member mm
    inner join flow.calendar_timezones c on c.id = mm.timezone_id
where mm.id = m.id and mm.sys_offset_id != c.offset_id;

vacuum analyze call_center.cc_member;
vacuum analyze call_center.cc_calls_history;
vacuum analyze call_center.cc_member_attempt_history;

vacuum full call_center.cc_member;
